# Features (Infrastructure)

Configure features of the fulfillmenttools platform.

## GET /api/features

> List features

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"Configure features of fulfillmenttools.","name":"Features (Infrastructure)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"Feature":{"allOf":[{"$ref":"#/components/schemas/VersionedResource"}],"properties":{"name":{"type":"string"},"status":{"$ref":"#/components/schemas/FeatureStatus"}},"required":["name","status"],"type":"object","title":"Feature","description":"Feature"},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"FeatureStatus":{"enum":["enabled","inactive","disabled"],"type":"string","title":"FeatureStatus","description":"FeatureStatus"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/features":{"get":{"description":"","operationId":"getFeatures","responses":{"200":{"content":{"application/json":{"schema":{"items":{"$ref":"#/components/schemas/Feature"}}}},"description":"The available feature for all active modules"},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"}},"summary":"List features","tags":["Features (Infrastructure)"]}}}}
```

## GET /api/features/{featureName}

> Get feature

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"Configure features of fulfillmenttools.","name":"Features (Infrastructure)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"Feature":{"allOf":[{"$ref":"#/components/schemas/VersionedResource"}],"properties":{"name":{"type":"string"},"status":{"$ref":"#/components/schemas/FeatureStatus"}},"required":["name","status"],"type":"object","title":"Feature","description":"Feature"},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"FeatureStatus":{"enum":["enabled","inactive","disabled"],"type":"string","title":"FeatureStatus","description":"FeatureStatus"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/features/{featureName}":{"get":{"description":"","operationId":"getFeature","parameters":[{"description":"Name of the feature requested","in":"path","name":"featureName","required":true,"schema":{"type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Feature"}}},"description":"The requested feature"},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"},"404":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Entity not found"}},"summary":"Get feature","tags":["Features (Infrastructure)"]}}}}
```

## PATCH /api/features/{featureName}

> Update feature

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"Configure features of fulfillmenttools.","name":"Features (Infrastructure)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"FeaturePatchActions":{"properties":{"actions":{"items":{"$ref":"#/components/schemas/ModifyFeature"},"minItems":1,"type":"array"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version","actions"],"type":"object","xml":{"name":"FeaturePatchActions"},"title":"FeaturePatchActions","description":"FeaturePatchActions"},"ModifyFeature":{"allOf":[{"$ref":"#/components/schemas/AbstractModificationAction"},{"additionalProperties":false,"properties":{"action":{"description":"Use value 'ModifyFeature', because you want to modify a Feature","enum":["ModifyFeature"],"type":"string"},"status":{"$ref":"#/components/schemas/FeatureStatus","description":"The state of the feature we want to change."}},"required":["action","status"],"type":"object"}],"xml":{"name":"ModifyFeature"},"title":"ModifyFeature","description":"ModifyFeature"},"AbstractModificationAction":{"discriminator":{"propertyName":"action"},"properties":{"action":{"description":"","enum":["AddAllowedValueToTag","ModifyPickJob","ModifyPickJobLastEditor","RestartPickJob","ResetPickJob","CancelPickRun","CancelHandoverjob","AbortPickJob","FinishPickRun","StartPickRun","ModifyPickLineItem","ModifyPickRunLineItem","ModifyPackJob","PausePackJob","ModifyPackLineItem","SplitLineItemsPackJob","ModifyFacility","ModifyListing","ModifyRetainedOfflineStock","ModifyListingReactivationAfter","ModifyUser","ModifyShipment","ModifyHandoverjob","ModifyCarrier","ModifyShortpick","ModifyRoutingPlan","ModifyFence","ModifyRating","ModifyTimingMode","ModifyGlobalRoutingConfiguration","ModifyOrderSplit","ModifyPrioritization","ModifyFeature","ModifyParcel","ModifyParcelLoadUnit","ModifyRestowItem","RemovePickJobFromPickRun","ModifyPartialStock","AddTagsToProcess","AssignFacilityToProcess","UpdateGdprCleanupDateAction","ModifyStorageLocation","ModifyPackingContainerType","ModifyPackingContainerTypeIcon","ReplaceCodesInPackingTargetContainer","AddLineItemToPackingTargetContainer","RemoveLineItemFromPackingTargetContainer","UpdateLineItemOnPackingTargetContainer","UpdatePackingTargetContainerLineItemRecordableAttributes","UpdatePackingTargetContainerStorageLocation","ModifyCustomService","UnlockOrder"],"type":"string"}},"required":["action"],"type":"object","xml":{"name":"AbstractModificationAction"},"title":"AbstractModificationAction","description":"AbstractModificationAction"},"FeatureStatus":{"enum":["enabled","inactive","disabled"],"type":"string","title":"FeatureStatus","description":"FeatureStatus"},"Feature":{"allOf":[{"$ref":"#/components/schemas/VersionedResource"}],"properties":{"name":{"type":"string"},"status":{"$ref":"#/components/schemas/FeatureStatus"}},"required":["name","status"],"type":"object","title":"Feature","description":"Feature"},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/features/{featureName}":{"patch":{"description":"","operationId":"patchFeature","parameters":[{"description":"Name of the feature requested","in":"path","name":"featureName","required":true,"schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/FeaturePatchActions"}}},"description":"Patch set","required":true},"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Feature"}}},"description":"Module was found & patch-set has been applied. The patched entity is in the body."},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"},"404":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Entity not found"},"409":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Entity version conflict"}},"summary":"Update feature","tags":["Features (Infrastructure)"]}}}}
```

## List scoped capabilities

> This part of the API is in Beta status. For details please check the \<a href="<https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta>" target="\_blank">api-release-life-cycle documentation\</a>.\<br />\<br />

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"Configure features of fulfillmenttools.","name":"Features (Infrastructure)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"ScopedCapability":{"allOf":[{"$ref":"#/components/schemas/VersionedResource"}],"properties":{"configurations":{"items":{"anyOf":[{"$ref":"#/components/schemas/CarrierConfiguration"},{"$ref":"#/components/schemas/SubstitutionConfiguration"},{"$ref":"#/components/schemas/RerouteShortPickConfiguration"},{"$ref":"#/components/schemas/ReturnNoteConfiguration"}]},"type":"array"},"currentUserPermissions":{"items":{"type":"string"},"type":"array"},"name":{"type":"string"},"status":{"$ref":"#/components/schemas/CapabilityStatus"}},"required":["name","status"],"type":"object","title":"ScopedCapability","description":"ScopedCapability"},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"CarrierConfiguration":{"properties":{"additionalWeightInPercent":{"description":"It is an amount of percentage for packaging weight which will be added to the calculated shipping weight","minimum":0,"type":"number"},"alternativeReturnAddress":{"allOf":[{"$ref":"#/components/schemas/FacilityAddress"}],"description":"Alternative return address for this carrier"},"alternativeSendAddress":{"allOf":[{"$ref":"#/components/schemas/FacilityAddress"}],"description":"Alternative send address for this carrier"},"carrierRef":{"description":"Reference to the carrier this configuration belongs to","type":"string"},"countryServiceMappings":{"description":"Country service mappings for this carrier configuration","items":{"$ref":"#/components/schemas/CarrierCountryServiceMapping"},"maxItems":100,"type":"array"},"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"defaultPickUpTime":{"allOf":[{"$ref":"#/components/schemas/CarrierPickUpTime"}],"description":"Default pick up time configuration for carriers supporting pick up scheduling, will be used to calculate the next possible pick up date"},"fallBackTrackAndTraceEmail":{"description":"EmailAddress used to receive track and trace information when no other emailaddress was provided","format":"email","minLength":1,"type":"string"},"id":{"description":"The id of the carrier configuration","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"mustBeWeighed":{"default":false,"description":"Indicates if the content of a parcel must be weighed before ordering a label","type":"boolean"},"nonDeliveryDaysPerCountryAndProvince":{"description":"Non-delivery days per country and province","items":{"$ref":"#/components/schemas/NonDeliveryDaysPerCountryAndProvince"},"maxItems":500,"type":"array"},"returnLabel":{"default":false,"description":"When enabled, a return label will be created by creating a shipping label","type":"boolean"},"serviceUrl":{"description":"Service URL for this carrier configuration","type":"string"},"thresholdPriceValue":{"allOf":[{"$ref":"#/components/schemas/ThresholdPriceValue"}],"description":"Threshold price value for carrier selection"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","type":"integer"}},"required":["version","carrierRef","returnLabel"],"title":"CarrierConfiguration","type":"object","description":"CarrierConfiguration"},"FacilityAddress":{"allOf":[{"$ref":"#/components/schemas/FacilityAddressForCreation"},{"properties":{"resolvedTimeZone":{"$ref":"#/components/schemas/TimeZone"}},"type":"object"}],"type":"object","xml":{"name":"FacilityAddress"},"title":"FacilityAddress","description":"FacilityAddress"},"FacilityAddressForCreation":{"allOf":[{"$ref":"#/components/schemas/Address"},{"properties":{"companyName":{"type":"string"},"emailAddresses":{"items":{"properties":{"recipient":{"description":"Human readable information who is the recipient for emails sent to this address.","type":"string"},"value":{"type":"string"}},"required":["value"],"type":"object"},"maxItems":10,"type":"array"},"resolvedCoordinates":{"$ref":"#/components/schemas/Coordinates"},"resolvedTimeZone":{"$ref":"#/components/schemas/TimeZoneForCreation","description":"User-specified time zone in identifier format (e.g., \"America/Los_Angeles\"). Used to determine local time. Relevant only if the country spans multiple time zones; otherwise, the time zone is automatically determined from the country or via Google if unspecified."}},"required":["companyName"],"type":"object"}],"type":"object","xml":{"name":"FacilityAddressForCreation"},"title":"FacilityAddressForCreation","description":"FacilityAddressForCreation"},"Address":{"properties":{"additionalAddressInfo":{"type":"string"},"city":{"pattern":"^.+$","type":"string"},"country":{"description":"A two-digit country code as per ISO 3166-1 alpha-2","pattern":"^[A-Z]{2}$","type":"string"},"customAttributes":{"description":"Attributes that can be added to the address. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","type":"object"},"houseNumber":{"pattern":"^.+$","type":"string"},"phoneNumbers":{"items":{"properties":{"customAttributes":{"description":"Attributes that can be added to the phonenumber. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","type":"object"},"label":{"description":"Can be used to give a description for the number, like \"private\", \"business number\", etc.","type":"string"},"type":{"enum":["MOBILE","PHONE"],"type":"string"},"value":{"description":"The number itself. We do not enforce any format (yet).","type":"string"}},"required":["value","type"],"type":"object"},"maxItems":500,"type":"array"},"postalCode":{"pattern":"^.+$","type":"string"},"province":{"pattern":"^.+$","type":"string"},"street":{"pattern":"^.+$","type":"string"}},"required":["street","city","postalCode","country"],"type":"object","title":"Address","description":"Address"},"Coordinates":{"description":"Coordinates of the WGS84 geodetic reference system in Mercator projection, as used e.g. by the Google Maps API","properties":{"lat":{"description":"Latitude value","type":"number"},"lon":{"description":"Longitude value","type":"number"}},"required":["lat","lon"],"type":"object","title":"Coordinates"},"TimeZoneForCreation":{"description":"Self-provided timezone for determining the local time of a facility","properties":{"timeZoneId":{"description":"official id of the timezone","type":"string"}},"required":["timeZoneId"],"type":"object","title":"TimeZoneForCreation"},"TimeZone":{"description":"Timezone for information retrieved e.g. by the Google Maps API","properties":{"offsetInSeconds":{"description":"offset in seconds to standard time. Does not account for daylight saving time.","type":"number"},"source":{"description":"source of the timezone information","type":"string"},"timeZoneId":{"description":"official id of the timezone","type":"string"},"timeZoneName":{"description":"descriptive name of the timezone","type":"string"}},"required":["timeZoneId","timeZoneName","offsetInSeconds"],"type":"object","title":"TimeZone"},"CarrierCountryServiceMapping":{"properties":{"additionalShippingArticleAttributes":{"description":"Article Attributes that will be displayed in the client as additional. They are not mandatory but could benefit the process.","items":{"$ref":"#/components/schemas/AdditionalShippingArticleAttribute"},"maxItems":20,"type":"array"},"additionalShippingAttributes":{"description":"Shipping Attributes that will be displayed in the client as additional. They are not mandatory but could benefit the process.","items":{"$ref":"#/components/schemas/AdditionalShippingAttribute"},"maxItems":30,"type":"array"},"carrierProductCategory":{"description":"Desired product class to choose when ordering a label","enum":["STANDARD","EXPRESS","VALUE","FORWARDING"],"type":"string"},"carrierServices":{"description":"Services which can be provided by the carrier","items":{"enum":["SIGNATURE","CUSTOMER_SIGNATURE","ADULT_SIGNATURE","SATURDAY_DELIVERY","IDENTITY_CHECK_COMPANY","IDENTITY_CHECK_PRIVATE","ADDITIONAL_TRANSPORTATION_INSURANCE","IDENTITY_AGE_CHECK_18","NO_NEIGHBOR_DELIVERY","HANDOVER_TO_RECIPIENT_ONLY"],"type":"string"},"maxItems":10,"type":"array"},"countAsTransitDayBefore":{"description":"Time before which this day counts as a transit day","type":"string"},"deliveryCosts":{"description":"Delivery costs for this mapping","items":{"$ref":"#/components/schemas/DeliveryCost"},"maxItems":1,"type":"array"},"destinationCountries":{"deprecated":true,"description":"deprecated - Use destinations instead.","items":{"type":"string"},"maxItems":250,"type":"array"},"destinations":{"description":"The destination regions this mapping should be applied to.","items":{"$ref":"#/components/schemas/RegionInformation"},"maxItems":250,"type":"array"},"id":{"description":"Unique identifier for a countryServiceMapping","type":"string"},"mandatoryShippingArticleAttributes":{"items":{"$ref":"#/components/schemas/MandatoryShippingArticleAttribute"},"maxItems":20,"type":"array"},"mandatoryShippingAttributes":{"items":{"$ref":"#/components/schemas/MandatoryShippingAttribute"},"maxItems":30,"type":"array"},"mandatoryShippingItemAttributes":{"deprecated":true,"description":"Deprecated - use mandatoryShippingArticleAttributes instead","items":{"$ref":"#/components/schemas/MandatoryShippingItemAttribute"},"maxItems":30,"type":"array"},"products":{"description":"Array of products for the given mapping","items":{"type":"string"},"maxItems":50,"type":"array"},"source":{"allOf":[{"$ref":"#/components/schemas/RegionInformation"}],"description":"Source region for this mapping"},"sourceCountry":{"deprecated":true,"description":"deprecated - Use source instead.","type":"string"},"staticCCSMRef":{"description":"Reference to a static country service mapping","type":"string"},"transitTime":{"allOf":[{"$ref":"#/components/schemas/CarrierTransitTime"}],"description":"Transit time configuration for this mapping"}},"required":["id","source","destinations"],"title":"CarrierCountryServiceMapping","type":"object","description":"CarrierCountryServiceMapping"},"AdditionalShippingArticleAttribute":{"properties":{"descriptionLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"Localized description of this shipping article attribute"},"category":{"description":"The category of this shipping article attribute","enum":["customs","dimensions","insurance"],"type":"string"},"dataType":{"description":"The data type of this shipping article attribute","enum":["NUMBER","STRING"],"type":"string"},"description":{"description":"Description of this shipping article attribute","type":"string"},"referencedField":{"description":"The referenced field for this shipping article attribute","enum":["attributes.weightPerUnit","attributes.hsCode","attributes.currency","attributes.valuePerUnit","attributes.countryOfManufacture"],"type":"string"}},"required":["referencedField","dataType","category","descriptionLocalized"],"title":"AdditionalShippingArticleAttribute","type":"object","description":"AdditionalShippingArticleAttribute"},"LocaleString":{"additionalProperties":{"type":"string"},"description":"Provides Localized values. The key is the locale, the value is the translation. https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/localization","title":"LocaleString","type":"object"},"AdditionalShippingAttribute":{"properties":{"descriptionLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"Localized description of this shipping attribute"},"dataType":{"description":"The data type of this shipping attribute","enum":["Number","String","Date","Boolean"],"type":"string"},"description":{"description":"Description of this shipping attribute","type":"string"},"referencedField":{"description":"- dimensions.weight: will be calculated from MandatoryShippingArticleAttribute.attributes.weightPerUnit if items with weightPerUnit is set on all items\n- productValue: will be calculated from MandatoryShippingArticleAttribute.attributes.pricePerUnit if items with pricePerUnit is set on all items","enum":["dimensions.weight","productValue","pickUpInformation.startTime","pickUpInformation.endTime","services.BulkyGoods","services.Signature","services.AdultSignature","services.CustomerSignature","services.SaturdayDelivery","services.IdentityCheckPrivate","services.IdentityCheckCompany","services.AdditionalTransportInsurance","carrierInformation.shippingContainerNumber","services.NoNeighborDelivery","services.HandoverToRecipientOnly","services.IdentityAgeCheck18"],"type":"string"}},"title":"AdditionalShippingAttribute","type":"object","description":"AdditionalShippingAttribute"},"DeliveryCost":{"properties":{"cost":{"description":"The cost of sending with a carrier","type":"number"},"currency":{"description":"The currency of the price as an ISO 4217 code.","type":"string"}},"required":["cost","currency"],"title":"DeliveryCost","type":"object","description":"DeliveryCost"},"RegionInformation":{"properties":{"countryCode":{"description":"ISO 3166 ALPHA-2 of country","maxLength":2,"minLength":2,"type":"string"},"postalCodes":{"description":"List of postal codes for this region","items":{"type":"string"},"maxItems":100,"type":"array"}},"required":["countryCode"],"title":"RegionInformation","type":"object","description":"RegionInformation"},"MandatoryShippingArticleAttribute":{"properties":{"descriptionLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"Localized description of this shipping article attribute"},"category":{"description":"The category of this shipping article attribute","enum":["customs","dimensions","insurance"],"type":"string"},"dataType":{"description":"The data type of this shipping article attribute","enum":["NUMBER","STRING"],"type":"string"},"description":{"description":"Description of this shipping article attribute","type":"string"},"referencedField":{"description":"The referenced field for this shipping article attribute","enum":["attributes.weightPerUnit","attributes.hsCode","attributes.currency","attributes.valuePerUnit","attributes.countryOfManufacture"],"type":"string"}},"required":["referencedField","dataType","category","descriptionLocalized"],"title":"MandatoryShippingArticleAttribute","type":"object","description":"MandatoryShippingArticleAttribute"},"MandatoryShippingAttribute":{"properties":{"descriptionLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"Localized description of this shipping attribute"},"dataType":{"description":"The data type of this shipping attribute","enum":["Number","String","Date","Boolean"],"type":"string"},"description":{"description":"Description of this shipping attribute","type":"string"},"referencedField":{"description":"- dimensions.weight: will be calculated from MandatoryShippingArticleAttribute.attributes.weightPerUnit if items with weightPerUnit is set on all items\n- productValue: will be calculated from MandatoryShippingArticleAttribute.attributes.pricePerUnit if items with pricePerUnit is set on all items","enum":["dimensions.weight","productValue","pickUpInformation.startTime","pickUpInformation.endTime","services.BulkyGoods","services.Signature","services.AdultSignature","services.CustomerSignature","services.SaturdayDelivery","services.IdentityCheckPrivate","services.IdentityCheckCompany","services.AdditionalTransportInsurance","carrierInformation.shippingContainerNumber","services.NoNeighborDelivery","services.HandoverToRecipientOnly","services.IdentityAgeCheck18"],"type":"string"}},"title":"MandatoryShippingAttribute","type":"object","description":"MandatoryShippingAttribute"},"MandatoryShippingItemAttribute":{"properties":{"descriptionLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"Localized description of this attribute"},"dataType":{"description":"The data type of this attribute","enum":["Number","String","Date","Boolean"],"type":"string"},"description":{"description":"Description of this attribute","type":"string"},"referencedField":{"deprecated":true,"description":"Deprecated: description: article.title will be used instead, weightInGram: use MandatoryShippingArticleAttribute.attributes.weightPerUnit","enum":["description","weightInGram","quantity","parcelItemValue.value","parcelItemValue.currency","countryOfManufacture","tenantArticleId"],"type":"string"}},"title":"MandatoryShippingItemAttribute","type":"object","description":"MandatoryShippingItemAttribute"},"CarrierTransitTime":{"properties":{"maxTransitDays":{"description":"Maximum days a carrier needs for transit","format":"int32","minimum":0,"type":"number"},"minTransitDays":{"description":"Minimum days a carrier needs for transit","format":"int32","minimum":0,"type":"number"}},"required":["minTransitDays","maxTransitDays"],"title":"CarrierTransitTime","type":"object","description":"CarrierTransitTime"},"CarrierPickUpTime":{"properties":{"end":{"allOf":[{"$ref":"#/components/schemas/TimeStamp"}],"description":"End time of the pick up window"},"start":{"allOf":[{"$ref":"#/components/schemas/TimeStamp"}],"description":"Start time of the pick up window"}},"required":["start","end"],"title":"CarrierPickUpTime","type":"object","description":"CarrierPickUpTime"},"TimeStamp":{"properties":{"hour":{"maximum":23,"minimum":0,"type":"number"},"minute":{"maximum":59,"minimum":0,"type":"number"}},"required":["hour","minute"],"type":"object","title":"TimeStamp","description":"TimeStamp"},"NonDeliveryDaysPerCountryAndProvince":{"properties":{"country":{"description":"The country code","type":"string"},"nonDeliveryDays":{"description":"Non-delivery days for this country","items":{"$ref":"#/components/schemas/NonDeliveryDays"},"maxItems":500,"type":"array"},"nonDeliveryDaysPerProvince":{"description":"Non-delivery days per province within this country","items":{"$ref":"#/components/schemas/NonDeliveryDaysPerProvince"},"maxItems":500,"type":"array"},"recurringNonDeliveryWeekdays":{"description":"Recurring non-delivery weekdays for this country","items":{"enum":["MONDAY","TUESDAY","WEDNESDAY","THURSDAY","FRIDAY","SATURDAY","SUNDAY"],"type":"string"},"maxItems":7,"type":"array"}},"required":["country","nonDeliveryDays","recurringNonDeliveryWeekdays","nonDeliveryDaysPerProvince"],"title":"NonDeliveryDaysPerCountryAndProvince","type":"object","description":"NonDeliveryDaysPerCountryAndProvince"},"NonDeliveryDays":{"properties":{"nonDeliveryDay":{"description":"The non-delivery day in YYYY-MM-DD format","format":"date","pattern":"^\\d{4}-\\d{2}-\\d{2}$","type":"string"},"nonDeliveryType":{"default":"SINGLE","description":"Type of non-delivery day","enum":["SINGLE","RECURRING"],"type":"string"}},"required":["nonDeliveryDay"],"title":"NonDeliveryDays","type":"object","description":"NonDeliveryDays"},"NonDeliveryDaysPerProvince":{"properties":{"nonDeliveryDays":{"description":"Non-delivery days for this province","items":{"$ref":"#/components/schemas/NonDeliveryDays"},"maxItems":500,"type":"array"},"province":{"description":"The province identifier","type":"string"},"recurringNonDeliveryWeekdays":{"description":"Recurring non-delivery weekdays for this province","items":{"enum":["MONDAY","TUESDAY","WEDNESDAY","THURSDAY","FRIDAY","SATURDAY","SUNDAY"],"type":"string"},"maxItems":7,"type":"array"}},"required":["province","nonDeliveryDays","recurringNonDeliveryWeekdays"],"title":"NonDeliveryDaysPerProvince","type":"object","description":"NonDeliveryDaysPerProvince"},"ThresholdPriceValue":{"properties":{"priceRange":{"allOf":[{"$ref":"#/components/schemas/PriceRange"}],"description":"Price range for which this threshold applies"},"priority":{"description":"The lower the value the higher is the priority, e.g. priority 1 is higher than priority 10. The priority is used when comparing multiple carriers.","minimum":1,"type":"number"}},"required":["priority","priceRange"],"title":"ThresholdPriceValue","type":"object","description":"ThresholdPriceValue"},"PriceRange":{"properties":{"currency":{"description":"The currency of the price as an ISO 4217 code.","type":"string"},"decimalPlaces":{"description":"Number of decimal places for the given currency","format":"int32","minimum":0,"type":"integer"},"from":{"description":"Lowest total parcel value that this carrier will be selected for. Value is configured in the smallest subunit, e.g. cents.","minimum":0,"type":"number"},"to":{"description":"Highest total parcel value that this carrier will be selected for. Value is configured in the smallest subunit, e.g. cents.","minimum":1,"type":"number"}},"required":["from","to","currency","decimalPlaces"],"title":"PriceRange","type":"object","description":"PriceRange"},"SubstitutionConfiguration":{"allOf":[{"$ref":"#/components/schemas/VersionedResource"}],"description":"Substitution Configuration","properties":{"active":{"default":true,"description":"Toggle for substitution articles.","type":"boolean"}},"required":["active"],"title":"SubstitutionConfiguration","type":"object"},"RerouteShortPickConfiguration":{"allOf":[{"$ref":"#/components/schemas/VersionedResource"}],"description":"Reroute ShortPick Configuration","properties":{"blacklistAssignedFacilities":{"default":false,"description":"Does not consider facilities which previously owned the pickjob during routing.","type":"boolean"},"clickAndCollectReroute":{"$ref":"#/components/schemas/ClickAndCollectRerouteConfiguration"},"id":{"type":"string"},"rerouteZeroPicksOnly":{"default":false,"description":"Specifies whether only pick jobs with zero items picked are eligible for rerouting.","type":"boolean"},"restowAfterMinutes":{"description":"The amount of minutes after which an automated restow is executed","type":"number"},"shipFromStoreReroute":{"$ref":"#/components/schemas/ShipFromStoreRerouteConfiguration"}},"required":["clickAndCollectReroute","shipFromStoreReroute"],"title":"RerouteShortPickConfiguration","type":"object"},"ClickAndCollectRerouteConfiguration":{"properties":{"active":{"type":"boolean"},"rerouteType":{"$ref":"#/components/schemas/RerouteType"}},"required":["active"],"type":"object","title":"ClickAndCollectRerouteConfiguration","description":"ClickAndCollectRerouteConfiguration"},"RerouteType":{"description":"The type of reroute to apply to the order\n  * `REROUTE`- the complete routing plan is rerouted.\n  * `ORDERSPLIT`- the order is splitted. The short picked line items will be moved to a new routing plan and rerouted","enum":["REROUTE","ORDERSPLIT"],"type":"string","title":"RerouteType"},"ShipFromStoreRerouteConfiguration":{"properties":{"active":{"type":"boolean"},"allowManualReroute":{"default":false,"deprecated":true,"description":"@deprecated This config property is deprecated since 26/02/24. Use GlobalManualRerouteConfiguration instead.","type":"boolean"},"facilityWideRerouteOnShortPick":{"default":false,"type":"boolean"},"rerouteTargetTime":{"description":"Only pickJobs where the targetTime in not larger than now plus this number are rerouted","type":"number"},"rerouteType":{"$ref":"#/components/schemas/RerouteType"}},"required":["active","rerouteType"],"type":"object","title":"ShipFromStoreRerouteConfiguration","description":"ShipFromStoreRerouteConfiguration"},"ReturnNoteConfiguration":{"allOf":[{"$ref":"#/components/schemas/VersionedResource"}],"description":"Return Note Configuration","properties":{"articleIdLabel":{"$ref":"#/components/schemas/LocaleString"},"articleTitleLabel":{"$ref":"#/components/schemas/LocaleString"},"companyAddress":{"$ref":"#/components/schemas/CompanyAddress"},"disclaimer":{"$ref":"#/components/schemas/LocaleString"},"disclaimerHeadline":{"$ref":"#/components/schemas/LocaleString"},"displayPageLabel":{"default":false,"description":"Determines if the page label should be shown","type":"boolean"},"headline":{"$ref":"#/components/schemas/LocaleString"},"id":{"type":"string"},"logoUrl":{"type":"string"},"orderDateLabel":{"$ref":"#/components/schemas/LocaleString"},"orderNumberLabel":{"$ref":"#/components/schemas/LocaleString"},"pageLabel":{"$ref":"#/components/schemas/LocaleString"},"pdfBackgroundConfiguration":{"$ref":"#/components/schemas/PdfBackgroundConfiguration"},"quantityLabel":{"$ref":"#/components/schemas/LocaleString"},"reasons":{"deprecated":true,"description":"Deprecated - use ReturnConfiguration.availableReturnReasons instead","items":{"$ref":"#/components/schemas/LocaleString"},"type":"array"},"returnReasonExplanation":{"$ref":"#/components/schemas/LocaleString"},"returnReasonExplanationHeadline":{"$ref":"#/components/schemas/LocaleString"},"returnReasonLabel":{"$ref":"#/components/schemas/LocaleString"},"substituteText":{"$ref":"#/components/schemas/LocaleString"}},"required":["id","orderDateLabel","orderNumberLabel","headline","quantityLabel","articleIdLabel","articleTitleLabel","returnReasonLabel","disclaimerHeadline","disclaimer","pageLabel"],"title":"ReturnNoteConfiguration","type":"object"},"CompanyAddress":{"properties":{"city":{"pattern":"^.+$","type":"string"},"country":{"pattern":"^.+$","type":"string"},"houseNumber":{"pattern":"^.+$","type":"string"},"name":{"pattern":"^.+$","type":"string"},"postalCode":{"pattern":"^.+$","type":"string"},"street":{"pattern":"^.+$","type":"string"}},"required":["name","street","postalCode","city","country"],"type":"object","title":"CompanyAddress","description":"CompanyAddress"},"PdfBackgroundConfiguration":{"properties":{"firstPageBackgroundFileUrl":{"description":"File url of the background image that will be used for the first page","type":"string"},"followingPageBackgroundFileUrl":{"description":"File url of background image that will be used for 2-n pages","type":"string"}},"type":"object","title":"PdfBackgroundConfiguration","description":"PdfBackgroundConfiguration"},"CapabilityStatus":{"enum":["enabled","inactive","disabled"],"type":"string","title":"CapabilityStatus","description":"CapabilityStatus"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/scopedcapabilities":{"get":{"description":"This part of the API is in Beta status. For details please check the <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta\" target=\"_blank\">api-release-life-cycle documentation</a>.<br /><br />","operationId":"getCapabilities","parameters":[{"description":"id of the facility","in":"query","name":"facilityId","required":false,"schema":{"type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"items":{"$ref":"#/components/schemas/ScopedCapability"}}}},"description":"All ScopedCapabilities which are at least inactive"},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"},"404":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Entity not found"}},"summary":"List scoped capabilities","tags":["Features (Infrastructure)"]}}}}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.fulfillmenttools.com/documentation/apis/api-reference/features-infrastructure.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
